<?php
date_default_timezone_set('America/Los_Angeles');

$clockSeq = hex2bin("351a");

$hidden_level = true;
$message = "";
$admin = "admin@example.com";
$conn = mysqli_connect('db', 'aethlios', 'password', "myDb");
if ($_SERVER["REQUEST_METHOD"] == "POST" && $_POST['email']) {
    include("token.php");
    $email = $_POST['email'];
    $level = 1;
    if ($_POST['level']) {
        $level = htmlspecialchars($_POST['level']);
    }
    $token = getToken($level, $email);
    $statement_select = mysqli_prepare($conn, "SELECT token FROM resetTolkien WHERE email = ?");
    mysqli_stmt_bind_param($statement_select, "s", $email);
    mysqli_stmt_execute($statement_select);
    $sql_select = mysqli_stmt_get_result($statement_select);
    if (mysqli_num_rows($sql_select) == 0) {
        $statement_insert = mysqli_prepare($conn, "INSERT INTO resetTolkien(email,token,level) VALUES(?, ?, ?)");
        mysqli_stmt_bind_param($statement_insert, "ssd", $email, $token, $level);
        mysqli_stmt_execute($statement_insert);
        $sql_insert = mysqli_stmt_get_result($statement_insert);
    } else {
        $statement_update = mysqli_prepare($conn, "UPDATE resetTolkien SET token = ?, level = ? WHERE email = ?");
        mysqli_stmt_bind_param($statement_update, "sds", $token, $level, $email);
        mysqli_stmt_execute($statement_update);
        $sql_update = mysqli_stmt_get_result($statement_update);
    }
    if ($email === $admin) {
        $message = 'Admin token has been generated with the level ' . $level;
    } else {
        $message = 'The link received by email is as follows: <a id="token" href="/?level=' . urlencode($level) . '&token=' . $token . '">' . $token . '</a>';
    }
}
if ($_SERVER["REQUEST_METHOD"] == "GET" && $_GET['token']) {
    $token = $_GET['token'];
    $statement_select2 = mysqli_prepare($conn, "SELECT * FROM resetTolkien WHERE token = ?");
    mysqli_stmt_bind_param($statement_select2, "s", $token);
    mysqli_stmt_execute($statement_select2);
    $sql_select2 = mysqli_stmt_get_result($statement_select2);
    if (mysqli_num_rows($sql_select2) == 0) {
        $message = "<p>Not found</p>";
    } else {
        $email = $sql_select2->fetch_array()["email"];
        $message = "<p>Found for " . htmlspecialchars($email) . "</p>";
        if ($email === $admin) {
            $message = $message . "<h2>Success!</h2>";
        }
        $sql_select2->close();
        $statement_delete = mysqli_prepare($conn, "DELETE FROM resetTolkien WHERE email = ? AND token = ?");
        mysqli_stmt_bind_param($statement_delete, "ss", $email, $token);
        mysqli_stmt_execute($statement_delete);
        $sql_delete = mysqli_stmt_get_result($statement_delete);
    }
}
mysqli_close($conn);
?>
<!DOCTYPE html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- Add icon library-->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <style>
        body {
            font-family: Arial, Helvetica, sans-serif;
        }

        * {
            box-sizing: border-box;
        }

        .input-container {
            display: -ms-flexbox;
            /* IE10 */
            display: flex;
            width: 100%;
            margin-bottom: 15px;
        }

        .icon {
            padding: 10px;
            background: green;
            color: white;
            min-width: 50px;
            text-align: center;
        }

        .input-field {
            width: 100%;
            padding: 10px;
            outline: none;
        }

        .input-field:focus {
            border: 2px solid dodgerblue;
        }

        /* Set a style for the submit button */
        .btn {
            /* background-color: dodgerblue; */
            background-color: grey;
            color: white;
            padding: 15px 20px;
            border: none;
            cursor: pointer;
            width: 100%;
            opacity: 0.9;
        }

        .btn:hover {
            opacity: 1;
        }

        .fa-passwd-reset>.fa-lock {
            font-size: 0.85rem;
        }
    </style>
</head>

<body>
    <form role="form" method="POST" style="max-width:500px;margin:auto">
        <center>
            <img height="400px" src="https://www.aeth.cc/public/aethlios.png">
        </center>
        <!-- Title  -->
        <center>
            <h2><span class="fa-passwd-reset fa-stack"><i class="fa fa-lock fa-stack-1x"></i></span>Reset your Password</h2>
            <h4>Try to reset the password of <?php echo $admin ?></h4>
        </center>
        <!-- First Input Text  -->
        <div class="input-container"><i class="fa fa-user icon" title="Email"></i>
            <input class="input-field" title="Email" id="email" placeholder="Type your email" name="email" value="<?php echo isset($_POST['email']) ? $_POST['email'] : ''; ?>" />
        </div>
        <!-- Second Input Text  -->
        <div class="input-container"><i class="fa fa-code-fork icon" title="Level"></i>
            <select class="input-field" name="level" title="Level">
                <option value="1" selected>Level 1<?php echo $hidden_level ? '' : ' - uniqid()'; ?></option>
                <option value="2">Level 2<?php echo $hidden_level ? '' : ' - sha1(time())'; ?> </option>
                <option value="3">Level 3<?php echo $hidden_level ? '' : ' - sha1(uniqid())'; ?> </option>
                <option value="4">Level 4<?php echo $hidden_level ? '' : ' - sha1(uniqid().$email)'; ?> </option>
                <option value="5">Level 5<?php echo $hidden_level ? '' : ' - sha1(date())'; ?> </option>
                <option value="6">Level 6<?php echo $hidden_level ? '' : ' - sha1($email.uniqid().$email)'; ?> </option>
                <option value="7">Level 7<?php echo $hidden_level ? '' : ' - uuid1()'; ?> </option>
            </select>
        </div>
        <button class="btn" id="formSubmit" type="submit">Reset your password</button>
    </form>
    <?php if ($message <> "") {
        echo '<div class="form-group">' . $message . '</div>';
    } ?>
</body>

</html>
