#!/usr/bin/env python

from flask import Flask, request, redirect, render_template
from markupsafe import Markup
from pymongo import MongoClient
from bson.objectid import ObjectId

VICTIM_EMAIL = "admin@example.com"

app = Flask(__name__)
db = MongoClient("mongodb://admin:admin@mongodb:27017")


# Store the token in database with the provided email
def store_in_db(email):
    reset = db["reset"]
    tokens = reset["tokens"]
    if tokens.find_one({"email": email}):
        tokens.delete_one({"email": email})
    return tokens.insert_one({"email": email}).inserted_id


def clear_token(token):
    reset = db["reset"]
    tokens = reset["tokens"]
    tokens.delete_one({"_id": ObjectId(token)})


# Verify the validity of provided token - the token is deleted from the database after usage
def verify(token):
    reset = db["reset"]
    tokens = reset["tokens"]
    db_token = tokens.find_one({"_id": ObjectId(token)})
    email = None
    if db_token:
        email = db_token["email"]
    return email


@app.route("/confirm", methods=["GET"])
def confirm():
    token = request.args.get("token", None)
    # Verify
    if token:
        if verify(token):
            clear_token(token)
            return "Account created!"
        return "Expired token!"
    return redirect("invite")


@app.route("/", methods=["GET"])
def index():
    return redirect("invite")


@app.route("/invite", methods=["GET"])
def invite():
    # Verify
    token = request.args.get("token", None)
    if token:
        email = verify(token)
        if email:
            return Markup("You are invite with %s! <a href='/confirm?token=%s'>Create my account</a>") % (email, token)
        return "Expired token!"

    # Generate
    email = request.args.get("email", None)
    if email:
        token = store_in_db(email)
        if token:
            if email == VICTIM_EMAIL:
                return Markup("Email sent to %s.") % email
            return Markup("Email sent to %s: <a id='token' href='/invite?token=%s'>%s</a>") % (email, token, token)
        return "Error"

    # Provide form
    return render_template("invitation.html")


import os

if __name__ == "__main__":
    app.run(host="0.0.0.0", port=os.environ.get("FLASK_SERVER_PORT", 9090), debug=True)
